// Use Plugin of Vite
const vitePluginScaff = require('@scaff/plugin');

// Use Kit
const { deepmerge, extension, inf, clean } = require('./kit');

// Init Scaff
module.exports = (api, options = {}, rootOptions = {}) => {
  // Get Configure from Vite
  const viteConfigure = vitePluginScaff().config();

  // Merge Options
  options = deepmerge(options, clean(viteConfigure));

  // Configure Webpack
  api.configureWebpack(webpackConfigure => {
    // Change Entry as Inside
    webpackConfigure.entry.app = inf.main;
  });

  // Extension Webpack
  api.chainWebpack(webpackConfigure => {
    // Merge Configure from Vite
    webpackConfigure = deepmerge(webpackConfigure, viteConfigure);

    // Extension for CLI
    webpackConfigure = extension(webpackConfigure, options);
  });
};
